/* bed.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "bed.h"

void *bedStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void bedEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void bedDasBedSave(struct bedDasBed *obj, int indent, FILE *f)
/* Save bedDasBed to file. */
{
struct bedSegment *bedSegment;
boolean isNode = TRUE;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DAS_BED");
fprintf(f, " id=\"%s\"", obj->id);
if (obj->version != NULL)
    fprintf(f, " version=\"%s\"", obj->version);
if (obj->label != NULL)
    fprintf(f, " label=\"%s\"", obj->label);
if (obj->description != NULL)
    fprintf(f, " description=\"%s\"", obj->description);
if (obj->author != NULL)
    fprintf(f, " author=\"%s\"", obj->author);
if (obj->href != NULL)
    fprintf(f, " href=\"%s\"", obj->href);
fprintf(f, ">");
if (obj->bedText != NULL)
    {
    if (isNode)
       {
       fprintf(f, "\n");
       isNode = FALSE;
       }
    bedTextSave(obj->bedText, indent+2, f);
    }
for (bedSegment = obj->bedSegment; bedSegment != NULL; bedSegment = bedSegment->next)
   {
   if (isNode)
       {
       fprintf(f, "\n");
       isNode = FALSE;
       }
   bedSegmentSave(bedSegment, indent+2, f);
   }
if (!isNode)
    xapIndent(indent, f);
fprintf(f, "</DAS_BED>\n");
}

struct bedDasBed *bedDasBedLoad(char *fileName)
/* Load bedDasBed from file. */
{
struct bedDasBed *obj;
xapParseAny(fileName, "DAS_BED", bedStartHandler, bedEndHandler, NULL, &obj);
return obj;
}

void bedTextSave(struct bedText *obj, int indent, FILE *f)
/* Save bedText to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TEXT>");
fprintf(f, "%s", obj->text);
fprintf(f, "</TEXT>\n");
}

struct bedText *bedTextLoad(char *fileName)
/* Load bedText from file. */
{
struct bedText *obj;
xapParseAny(fileName, "TEXT", bedStartHandler, bedEndHandler, NULL, &obj);
return obj;
}

void bedSegmentSave(struct bedSegment *obj, int indent, FILE *f)
/* Save bedSegment to file. */
{
struct bedF *bedF;
boolean isNode = TRUE;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SEGMENT");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, " start=\"%d\"", obj->start);
fprintf(f, " end=\"%d\"", obj->end);
fprintf(f, " strand=\"%s\"", obj->strand);
fprintf(f, ">");
for (bedF = obj->bedF; bedF != NULL; bedF = bedF->next)
   {
   if (isNode)
       {
       fprintf(f, "\n");
       isNode = FALSE;
       }
   bedFSave(bedF, indent+2, f);
   }
if (!isNode)
    xapIndent(indent, f);
fprintf(f, "</SEGMENT>\n");
}

struct bedSegment *bedSegmentLoad(char *fileName)
/* Load bedSegment from file. */
{
struct bedSegment *obj;
xapParseAny(fileName, "SEGMENT", bedStartHandler, bedEndHandler, NULL, &obj);
return obj;
}

void bedFSave(struct bedF *obj, int indent, FILE *f)
/* Save bedF to file. */
{
struct bedText *bedText;
struct bedF *bedF;
struct bedB *bedB;
boolean isNode = TRUE;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<F");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, " start=\"%d\"", obj->start);
fprintf(f, " end=\"%d\"", obj->end);
if (obj->label != NULL)
    fprintf(f, " label=\"%s\"", obj->label);
if (obj->version != NULL)
    fprintf(f, " version=\"%s\"", obj->version);
if (obj->description != NULL)
    fprintf(f, " description=\"%s\"", obj->description);
if (obj->author != NULL)
    fprintf(f, " author=\"%s\"", obj->author);
if (obj->href != NULL)
    fprintf(f, " href=\"%s\"", obj->href);
if (obj->strand != NULL)
    fprintf(f, " strand=\"%s\"", obj->strand);
if (obj->score >= 0)
    fprintf(f, " score=\"%d\"", obj->score);
if (obj->thickStart >= 0)
    fprintf(f, " thickStart=\"%d\"", obj->thickStart);
if (obj->thickEnd >= 0)
    fprintf(f, " thickEnd=\"%d\"", obj->thickEnd);
if (obj->frame >= 0)
    fprintf(f, " frame=\"%d\"", obj->frame);
if (obj->qId != NULL)
    fprintf(f, " qId=\"%s\"", obj->qId);
fprintf(f, ">");
for (bedText = obj->bedText; bedText != NULL; bedText = bedText->next)
   {
   if (isNode)
       {
       fprintf(f, "\n");
       isNode = FALSE;
       }
   bedTextSave(bedText, indent+2, f);
   }
for (bedF = obj->bedF; bedF != NULL; bedF = bedF->next)
   {
   if (isNode)
       {
       fprintf(f, "\n");
       isNode = FALSE;
       }
   bedFSave(bedF, indent+2, f);
   }
for (bedB = obj->bedB; bedB != NULL; bedB = bedB->next)
   {
   if (isNode)
       {
       fprintf(f, "\n");
       isNode = FALSE;
       }
   bedBSave(bedB, indent+2, f);
   }
if (!isNode)
    xapIndent(indent, f);
fprintf(f, "</F>\n");
}

struct bedF *bedFLoad(char *fileName)
/* Load bedF from file. */
{
struct bedF *obj;
xapParseAny(fileName, "F", bedStartHandler, bedEndHandler, NULL, &obj);
return obj;
}

void bedBSave(struct bedB *obj, int indent, FILE *f)
/* Save bedB to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<B");
fprintf(f, " start=\"%d\"", obj->start);
fprintf(f, " end=\"%d\"", obj->end);
if (obj->score >= 0)
    fprintf(f, " score=\"%d\"", obj->score);
if (obj->qAli != NULL)
    fprintf(f, " qAli=\"%s\"", obj->qAli);
if (obj->tAli != NULL)
    fprintf(f, " tAli=\"%s\"", obj->tAli);
if (obj->qStart >= 0)
    fprintf(f, " qStart=\"%d\"", obj->qStart);
if (obj->qEnd >= 0)
    fprintf(f, " qEnd=\"%d\"", obj->qEnd);
fprintf(f, "->\n");
}

struct bedB *bedBLoad(char *fileName)
/* Load bedB from file. */
{
struct bedB *obj;
xapParseAny(fileName, "B", bedStartHandler, bedEndHandler, NULL, &obj);
return obj;
}

void *bedStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DAS_BED"))
    {
    struct bedDasBed *obj;
    AllocVar(obj);
    obj->version = "1.0";
    obj->author = "anonymous";
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        else if (sameString(name, "label"))
            obj->label = cloneString(val);
        else if (sameString(name, "description"))
            obj->description = cloneString(val);
        else if (sameString(name, "author"))
            obj->author = cloneString(val);
        else if (sameString(name, "href"))
            obj->href = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    return obj;
    }
else if (sameString(name, "TEXT"))
    {
    struct bedText *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "DAS_BED"))
            {
            struct bedDasBed *parent = st->object;
            slAddHead(&parent->bedText, obj);
            }
        else if (sameString(st->elName, "F"))
            {
            struct bedF *parent = st->object;
            slAddHead(&parent->bedText, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "SEGMENT"))
    {
    struct bedSegment *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        else if (sameString(name, "start"))
            obj->start = atoi(val);
        else if (sameString(name, "end"))
            obj->end = atoi(val);
        else if (sameString(name, "strand"))
            obj->strand = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (obj->version == NULL)
        xapError(xp, "missing version");
    if (obj->strand == NULL)
        xapError(xp, "missing strand");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DAS_BED"))
            {
            struct bedDasBed *parent = st->object;
            slAddHead(&parent->bedSegment, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "F"))
    {
    struct bedF *obj;
    AllocVar(obj);
    obj->score = -1;
    obj->thickStart = -1;
    obj->thickEnd = -1;
    obj->frame = -1;
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "start"))
            obj->start = atoi(val);
        else if (sameString(name, "end"))
            obj->end = atoi(val);
        else if (sameString(name, "label"))
            obj->label = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        else if (sameString(name, "description"))
            obj->description = cloneString(val);
        else if (sameString(name, "author"))
            obj->author = cloneString(val);
        else if (sameString(name, "href"))
            obj->href = cloneString(val);
        else if (sameString(name, "strand"))
            obj->strand = cloneString(val);
        else if (sameString(name, "score"))
            obj->score = atoi(val);
        else if (sameString(name, "thickStart"))
            obj->thickStart = atoi(val);
        else if (sameString(name, "thickEnd"))
            obj->thickEnd = atoi(val);
        else if (sameString(name, "frame"))
            obj->frame = atoi(val);
        else if (sameString(name, "qId"))
            obj->qId = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "SEGMENT"))
            {
            struct bedSegment *parent = st->object;
            slAddHead(&parent->bedF, obj);
            }
        else if (sameString(st->elName, "F"))
            {
            struct bedF *parent = st->object;
            slAddHead(&parent->bedF, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "B"))
    {
    struct bedB *obj;
    AllocVar(obj);
    obj->score = -1;
    obj->qStart = -1;
    obj->qEnd = -1;
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "start"))
            obj->start = atoi(val);
        else if (sameString(name, "end"))
            obj->end = atoi(val);
        else if (sameString(name, "score"))
            obj->score = atoi(val);
        else if (sameString(name, "qAli"))
            obj->qAli = cloneString(val);
        else if (sameString(name, "tAli"))
            obj->tAli = cloneString(val);
        else if (sameString(name, "qStart"))
            obj->qStart = atoi(val);
        else if (sameString(name, "qEnd"))
            obj->qEnd = atoi(val);
        }
    if (depth > 1)
        {
        if  (sameString(st->elName, "F"))
            {
            struct bedF *parent = st->object;
            slAddHead(&parent->bedB, obj);
            }
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void bedEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DAS_BED"))
    {
    struct bedDasBed *obj = stack->object;
    if (obj->bedText != NULL && obj->bedText->next != NULL)
        xapError(xp, "Multiple TEXT");
    slReverse(&obj->bedSegment);
    }
else if (sameString(name, "TEXT"))
    {
    struct bedText *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "SEGMENT"))
    {
    struct bedSegment *obj = stack->object;
    slReverse(&obj->bedF);
    }
else if (sameString(name, "F"))
    {
    struct bedF *obj = stack->object;
    slReverse(&obj->bedText);
    slReverse(&obj->bedF);
    slReverse(&obj->bedB);
    }
}

int main(int argc, char *argv[])
/* Test driver for bed routines */
{
struct bedDasBed *obj;
if (argc != 2)
    errAbort("Please run again with a xml filename.");
obj = bedDasBedLoad(argv[1]);
bedDasBedSave(obj, -1000, stdout);
return 0;
}
