/* ds.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "ds.h"

void *dsStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void dsEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void dsDasstyleSave(struct dsDasstyle *obj, int indent, FILE *f)
/* Save dsDasstyle to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASSTYLE>");
fprintf(f, "\n");
dsStylesheetSave(obj->dsStylesheet, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASSTYLE>\n");
}

struct dsDasstyle *dsDasstyleLoad(char *fileName)
/* Load dsDasstyle from file. */
{
struct dsDasstyle *obj;
xapParseAny(fileName, "DASSTYLE", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsStylesheetSave(struct dsStylesheet *obj, int indent, FILE *f)
/* Save dsStylesheet to file. */
{
struct dsCategory *dsCategory;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<STYLESHEET");
fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, ">");
fprintf(f, "\n");
for (dsCategory = obj->dsCategory; dsCategory != NULL; dsCategory = dsCategory->next)
   dsCategorySave(dsCategory, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</STYLESHEET>\n");
}

struct dsStylesheet *dsStylesheetLoad(char *fileName)
/* Load dsStylesheet from file. */
{
struct dsStylesheet *obj;
xapParseAny(fileName, "STYLESHEET", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsCategorySave(struct dsCategory *obj, int indent, FILE *f)
/* Save dsCategory to file. */
{
struct dsType *dsType;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<CATEGORY");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, ">");
fprintf(f, "\n");
for (dsType = obj->dsType; dsType != NULL; dsType = dsType->next)
   dsTypeSave(dsType, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</CATEGORY>\n");
}

struct dsCategory *dsCategoryLoad(char *fileName)
/* Load dsCategory from file. */
{
struct dsCategory *obj;
xapParseAny(fileName, "CATEGORY", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsTypeSave(struct dsType *obj, int indent, FILE *f)
/* Save dsType to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TYPE");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, ">");
fprintf(f, "\n");
dsGlyphSave(obj->dsGlyph, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</TYPE>\n");
}

struct dsType *dsTypeLoad(char *fileName)
/* Load dsType from file. */
{
struct dsType *obj;
xapParseAny(fileName, "TYPE", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsGlyphSave(struct dsGlyph *obj, int indent, FILE *f)
/* Save dsGlyph to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<GLYPH>");
fprintf(f, "\n");
dsBoxSave(obj->dsBox, indent+2, f);
dsToomanySave(obj->dsToomany, indent+2, f);
dsArrowSave(obj->dsArrow, indent+2, f);
dsLineSave(obj->dsLine, indent+2, f);
dsConnectorSave(obj->dsConnector, indent+2, f);
dsTextSave(obj->dsText, indent+2, f);
dsExSave(obj->dsEx, indent+2, f);
dsCrossSave(obj->dsCross, indent+2, f);
dsDotSave(obj->dsDot, indent+2, f);
dsTriangleSave(obj->dsTriangle, indent+2, f);
dsSpanSave(obj->dsSpan, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</GLYPH>\n");
}

struct dsGlyph *dsGlyphLoad(char *fileName)
/* Load dsGlyph from file. */
{
struct dsGlyph *obj;
xapParseAny(fileName, "GLYPH", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsBoxSave(struct dsBox *obj, int indent, FILE *f)
/* Save dsBox to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<BOX>");
fprintf(f, "\n");
dsWidthSave(obj->dsWidth, indent+2, f);
dsColorSave(obj->dsColor, indent+2, f);
dsOutlinecolorSave(obj->dsOutlinecolor, indent+2, f);
dsLinewidthSave(obj->dsLinewidth, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</BOX>\n");
}

struct dsBox *dsBoxLoad(char *fileName)
/* Load dsBox from file. */
{
struct dsBox *obj;
xapParseAny(fileName, "BOX", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsToomanySave(struct dsToomany *obj, int indent, FILE *f)
/* Save dsToomany to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TOOMANY>");
fprintf(f, "\n");
dsWidthSave(obj->dsWidth, indent+2, f);
dsColorSave(obj->dsColor, indent+2, f);
dsOutlinecolorSave(obj->dsOutlinecolor, indent+2, f);
dsLinewidthSave(obj->dsLinewidth, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</TOOMANY>\n");
}

struct dsToomany *dsToomanyLoad(char *fileName)
/* Load dsToomany from file. */
{
struct dsToomany *obj;
xapParseAny(fileName, "TOOMANY", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsArrowSave(struct dsArrow *obj, int indent, FILE *f)
/* Save dsArrow to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<ARROW>");
fprintf(f, "\n");
dsWidthSave(obj->dsWidth, indent+2, f);
dsColorSave(obj->dsColor, indent+2, f);
dsParallelSave(obj->dsParallel, indent+2, f);
dsNortheastSave(obj->dsNortheast, indent+2, f);
dsSouthwestSave(obj->dsSouthwest, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</ARROW>\n");
}

struct dsArrow *dsArrowLoad(char *fileName)
/* Load dsArrow from file. */
{
struct dsArrow *obj;
xapParseAny(fileName, "ARROW", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsLineSave(struct dsLine *obj, int indent, FILE *f)
/* Save dsLine to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<LINE>");
fprintf(f, "\n");
dsWidthSave(obj->dsWidth, indent+2, f);
dsColorSave(obj->dsColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</LINE>\n");
}

struct dsLine *dsLineLoad(char *fileName)
/* Load dsLine from file. */
{
struct dsLine *obj;
xapParseAny(fileName, "LINE", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsConnectorSave(struct dsConnector *obj, int indent, FILE *f)
/* Save dsConnector to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<CONNECTOR>");
fprintf(f, "\n");
dsWidthSave(obj->dsWidth, indent+2, f);
dsColorSave(obj->dsColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</CONNECTOR>\n");
}

struct dsConnector *dsConnectorLoad(char *fileName)
/* Load dsConnector from file. */
{
struct dsConnector *obj;
xapParseAny(fileName, "CONNECTOR", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsTextSave(struct dsText *obj, int indent, FILE *f)
/* Save dsText to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TEXT>");
fprintf(f, "\n");
dsFontSave(obj->dsFont, indent+2, f);
dsFontsizeSave(obj->dsFontsize, indent+2, f);
dsStringSave(obj->dsString, indent+2, f);
dsStyleSave(obj->dsStyle, indent+2, f);
dsColorSave(obj->dsColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</TEXT>\n");
}

struct dsText *dsTextLoad(char *fileName)
/* Load dsText from file. */
{
struct dsText *obj;
xapParseAny(fileName, "TEXT", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsExSave(struct dsEx *obj, int indent, FILE *f)
/* Save dsEx to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<EX>");
fprintf(f, "\n");
dsWidthSave(obj->dsWidth, indent+2, f);
dsColorSave(obj->dsColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</EX>\n");
}

struct dsEx *dsExLoad(char *fileName)
/* Load dsEx from file. */
{
struct dsEx *obj;
xapParseAny(fileName, "EX", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsCrossSave(struct dsCross *obj, int indent, FILE *f)
/* Save dsCross to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<CROSS>");
fprintf(f, "\n");
dsWidthSave(obj->dsWidth, indent+2, f);
dsColorSave(obj->dsColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</CROSS>\n");
}

struct dsCross *dsCrossLoad(char *fileName)
/* Load dsCross from file. */
{
struct dsCross *obj;
xapParseAny(fileName, "CROSS", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsDotSave(struct dsDot *obj, int indent, FILE *f)
/* Save dsDot to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DOT>");
fprintf(f, "\n");
dsWidthSave(obj->dsWidth, indent+2, f);
dsColorSave(obj->dsColor, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DOT>\n");
}

struct dsDot *dsDotLoad(char *fileName)
/* Load dsDot from file. */
{
struct dsDot *obj;
xapParseAny(fileName, "DOT", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsTriangleSave(struct dsTriangle *obj, int indent, FILE *f)
/* Save dsTriangle to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TRIANGLE>");
fprintf(f, "\n");
dsColorSave(obj->dsColor, indent+2, f);
dsWidthSave(obj->dsWidth, indent+2, f);
dsOutlinecolorSave(obj->dsOutlinecolor, indent+2, f);
dsLinewidthSave(obj->dsLinewidth, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</TRIANGLE>\n");
}

struct dsTriangle *dsTriangleLoad(char *fileName)
/* Load dsTriangle from file. */
{
struct dsTriangle *obj;
xapParseAny(fileName, "TRIANGLE", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsSpanSave(struct dsSpan *obj, int indent, FILE *f)
/* Save dsSpan to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SPAN>");
fprintf(f, "\n");
dsColorSave(obj->dsColor, indent+2, f);
dsWidthSave(obj->dsWidth, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</SPAN>\n");
}

struct dsSpan *dsSpanLoad(char *fileName)
/* Load dsSpan from file. */
{
struct dsSpan *obj;
xapParseAny(fileName, "SPAN", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsWidthSave(struct dsWidth *obj, int indent, FILE *f)
/* Save dsWidth to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<WIDTH>");
fprintf(f, "%s", obj->text);
fprintf(f, "</WIDTH>\n");
}

struct dsWidth *dsWidthLoad(char *fileName)
/* Load dsWidth from file. */
{
struct dsWidth *obj;
xapParseAny(fileName, "WIDTH", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsColorSave(struct dsColor *obj, int indent, FILE *f)
/* Save dsColor to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<COLOR>");
fprintf(f, "%s", obj->text);
fprintf(f, "</COLOR>\n");
}

struct dsColor *dsColorLoad(char *fileName)
/* Load dsColor from file. */
{
struct dsColor *obj;
xapParseAny(fileName, "COLOR", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsOutlinecolorSave(struct dsOutlinecolor *obj, int indent, FILE *f)
/* Save dsOutlinecolor to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<OUTLINECOLOR>");
fprintf(f, "%s", obj->text);
fprintf(f, "</OUTLINECOLOR>\n");
}

struct dsOutlinecolor *dsOutlinecolorLoad(char *fileName)
/* Load dsOutlinecolor from file. */
{
struct dsOutlinecolor *obj;
xapParseAny(fileName, "OUTLINECOLOR", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsLinewidthSave(struct dsLinewidth *obj, int indent, FILE *f)
/* Save dsLinewidth to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<LINEWIDTH>");
fprintf(f, "%s", obj->text);
fprintf(f, "</LINEWIDTH>\n");
}

struct dsLinewidth *dsLinewidthLoad(char *fileName)
/* Load dsLinewidth from file. */
{
struct dsLinewidth *obj;
xapParseAny(fileName, "LINEWIDTH", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsParallelSave(struct dsParallel *obj, int indent, FILE *f)
/* Save dsParallel to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<PARALLEL>");
fprintf(f, "%s", obj->text);
fprintf(f, "</PARALLEL>\n");
}

struct dsParallel *dsParallelLoad(char *fileName)
/* Load dsParallel from file. */
{
struct dsParallel *obj;
xapParseAny(fileName, "PARALLEL", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsNortheastSave(struct dsNortheast *obj, int indent, FILE *f)
/* Save dsNortheast to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<NORTHEAST>");
fprintf(f, "%s", obj->text);
fprintf(f, "</NORTHEAST>\n");
}

struct dsNortheast *dsNortheastLoad(char *fileName)
/* Load dsNortheast from file. */
{
struct dsNortheast *obj;
xapParseAny(fileName, "NORTHEAST", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsSouthwestSave(struct dsSouthwest *obj, int indent, FILE *f)
/* Save dsSouthwest to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SOUTHWEST>");
fprintf(f, "%s", obj->text);
fprintf(f, "</SOUTHWEST>\n");
}

struct dsSouthwest *dsSouthwestLoad(char *fileName)
/* Load dsSouthwest from file. */
{
struct dsSouthwest *obj;
xapParseAny(fileName, "SOUTHWEST", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsFontSave(struct dsFont *obj, int indent, FILE *f)
/* Save dsFont to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<FONT>");
fprintf(f, "%s", obj->text);
fprintf(f, "</FONT>\n");
}

struct dsFont *dsFontLoad(char *fileName)
/* Load dsFont from file. */
{
struct dsFont *obj;
xapParseAny(fileName, "FONT", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsFontsizeSave(struct dsFontsize *obj, int indent, FILE *f)
/* Save dsFontsize to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<FONTSIZE>");
fprintf(f, "%s", obj->text);
fprintf(f, "</FONTSIZE>\n");
}

struct dsFontsize *dsFontsizeLoad(char *fileName)
/* Load dsFontsize from file. */
{
struct dsFontsize *obj;
xapParseAny(fileName, "FONTSIZE", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsStringSave(struct dsString *obj, int indent, FILE *f)
/* Save dsString to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<STRING>");
fprintf(f, "%s", obj->text);
fprintf(f, "</STRING>\n");
}

struct dsString *dsStringLoad(char *fileName)
/* Load dsString from file. */
{
struct dsString *obj;
xapParseAny(fileName, "STRING", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void dsStyleSave(struct dsStyle *obj, int indent, FILE *f)
/* Save dsStyle to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<STYLE>");
fprintf(f, "%s", obj->text);
fprintf(f, "</STYLE>\n");
}

struct dsStyle *dsStyleLoad(char *fileName)
/* Load dsStyle from file. */
{
struct dsStyle *obj;
xapParseAny(fileName, "STYLE", dsStartHandler, dsEndHandler, NULL, &obj);
return obj;
}

void *dsStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASSTYLE"))
    {
    struct dsDasstyle *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "STYLESHEET"))
    {
    struct dsStylesheet *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "version"))
            obj->version = cloneString(val);
        }
    if (obj->version == NULL)
        xapError(xp, "missing version");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASSTYLE"))
            {
            struct dsDasstyle *parent = st->object;
            slAddHead(&parent->dsStylesheet, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "CATEGORY"))
    {
    struct dsCategory *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "STYLESHEET"))
            {
            struct dsStylesheet *parent = st->object;
            slAddHead(&parent->dsCategory, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "TYPE"))
    {
    struct dsType *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "CATEGORY"))
            {
            struct dsCategory *parent = st->object;
            slAddHead(&parent->dsType, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "GLYPH"))
    {
    struct dsGlyph *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "TYPE"))
            {
            struct dsType *parent = st->object;
            slAddHead(&parent->dsGlyph, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "BOX"))
    {
    struct dsBox *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsBox, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "TOOMANY"))
    {
    struct dsToomany *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsToomany, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "ARROW"))
    {
    struct dsArrow *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsArrow, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "LINE"))
    {
    struct dsLine *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsLine, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "CONNECTOR"))
    {
    struct dsConnector *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsConnector, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "TEXT"))
    {
    struct dsText *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsText, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "EX"))
    {
    struct dsEx *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsEx, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "CROSS"))
    {
    struct dsCross *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsCross, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "DOT"))
    {
    struct dsDot *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsDot, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "TRIANGLE"))
    {
    struct dsTriangle *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsTriangle, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "SPAN"))
    {
    struct dsSpan *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GLYPH"))
            {
            struct dsGlyph *parent = st->object;
            slAddHead(&parent->dsSpan, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "WIDTH"))
    {
    struct dsWidth *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "BOX"))
            {
            struct dsBox *parent = st->object;
            slAddHead(&parent->dsWidth, obj);
            }
        else if (sameString(st->elName, "TOOMANY"))
            {
            struct dsToomany *parent = st->object;
            slAddHead(&parent->dsWidth, obj);
            }
        else if (sameString(st->elName, "ARROW"))
            {
            struct dsArrow *parent = st->object;
            slAddHead(&parent->dsWidth, obj);
            }
        else if (sameString(st->elName, "LINE"))
            {
            struct dsLine *parent = st->object;
            slAddHead(&parent->dsWidth, obj);
            }
        else if (sameString(st->elName, "CONNECTOR"))
            {
            struct dsConnector *parent = st->object;
            slAddHead(&parent->dsWidth, obj);
            }
        else if (sameString(st->elName, "EX"))
            {
            struct dsEx *parent = st->object;
            slAddHead(&parent->dsWidth, obj);
            }
        else if (sameString(st->elName, "CROSS"))
            {
            struct dsCross *parent = st->object;
            slAddHead(&parent->dsWidth, obj);
            }
        else if (sameString(st->elName, "DOT"))
            {
            struct dsDot *parent = st->object;
            slAddHead(&parent->dsWidth, obj);
            }
        else if (sameString(st->elName, "TRIANGLE"))
            {
            struct dsTriangle *parent = st->object;
            slAddHead(&parent->dsWidth, obj);
            }
        else if (sameString(st->elName, "SPAN"))
            {
            struct dsSpan *parent = st->object;
            slAddHead(&parent->dsWidth, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "COLOR"))
    {
    struct dsColor *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "BOX"))
            {
            struct dsBox *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else if (sameString(st->elName, "TOOMANY"))
            {
            struct dsToomany *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else if (sameString(st->elName, "ARROW"))
            {
            struct dsArrow *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else if (sameString(st->elName, "LINE"))
            {
            struct dsLine *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else if (sameString(st->elName, "CONNECTOR"))
            {
            struct dsConnector *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else if (sameString(st->elName, "TEXT"))
            {
            struct dsText *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else if (sameString(st->elName, "EX"))
            {
            struct dsEx *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else if (sameString(st->elName, "CROSS"))
            {
            struct dsCross *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else if (sameString(st->elName, "DOT"))
            {
            struct dsDot *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else if (sameString(st->elName, "TRIANGLE"))
            {
            struct dsTriangle *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else if (sameString(st->elName, "SPAN"))
            {
            struct dsSpan *parent = st->object;
            slAddHead(&parent->dsColor, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "OUTLINECOLOR"))
    {
    struct dsOutlinecolor *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "BOX"))
            {
            struct dsBox *parent = st->object;
            slAddHead(&parent->dsOutlinecolor, obj);
            }
        else if (sameString(st->elName, "TOOMANY"))
            {
            struct dsToomany *parent = st->object;
            slAddHead(&parent->dsOutlinecolor, obj);
            }
        else if (sameString(st->elName, "TRIANGLE"))
            {
            struct dsTriangle *parent = st->object;
            slAddHead(&parent->dsOutlinecolor, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "LINEWIDTH"))
    {
    struct dsLinewidth *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "BOX"))
            {
            struct dsBox *parent = st->object;
            slAddHead(&parent->dsLinewidth, obj);
            }
        else if (sameString(st->elName, "TOOMANY"))
            {
            struct dsToomany *parent = st->object;
            slAddHead(&parent->dsLinewidth, obj);
            }
        else if (sameString(st->elName, "TRIANGLE"))
            {
            struct dsTriangle *parent = st->object;
            slAddHead(&parent->dsLinewidth, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "PARALLEL"))
    {
    struct dsParallel *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "ARROW"))
            {
            struct dsArrow *parent = st->object;
            slAddHead(&parent->dsParallel, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "NORTHEAST"))
    {
    struct dsNortheast *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "ARROW"))
            {
            struct dsArrow *parent = st->object;
            slAddHead(&parent->dsNortheast, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "SOUTHWEST"))
    {
    struct dsSouthwest *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "ARROW"))
            {
            struct dsArrow *parent = st->object;
            slAddHead(&parent->dsSouthwest, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "FONT"))
    {
    struct dsFont *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "TEXT"))
            {
            struct dsText *parent = st->object;
            slAddHead(&parent->dsFont, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "FONTSIZE"))
    {
    struct dsFontsize *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "TEXT"))
            {
            struct dsText *parent = st->object;
            slAddHead(&parent->dsFontsize, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "STRING"))
    {
    struct dsString *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "TEXT"))
            {
            struct dsText *parent = st->object;
            slAddHead(&parent->dsString, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "STYLE"))
    {
    struct dsStyle *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "TEXT"))
            {
            struct dsText *parent = st->object;
            slAddHead(&parent->dsStyle, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void dsEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASSTYLE"))
    {
    struct dsDasstyle *obj = stack->object;
    if (obj->dsStylesheet == NULL)
        xapError(xp, "Missing STYLESHEET");
    if (obj->dsStylesheet->next != NULL)
        xapError(xp, "Multiple STYLESHEET");
    }
else if (sameString(name, "STYLESHEET"))
    {
    struct dsStylesheet *obj = stack->object;
    if (obj->dsCategory == NULL)
        xapError(xp, "Missing CATEGORY");
    }
else if (sameString(name, "CATEGORY"))
    {
    struct dsCategory *obj = stack->object;
    if (obj->dsType == NULL)
        xapError(xp, "Missing TYPE");
    }
else if (sameString(name, "TYPE"))
    {
    struct dsType *obj = stack->object;
    if (obj->dsGlyph == NULL)
        xapError(xp, "Missing GLYPH");
    if (obj->dsGlyph->next != NULL)
        xapError(xp, "Multiple GLYPH");
    }
else if (sameString(name, "GLYPH"))
    {
    struct dsGlyph *obj = stack->object;
    if (obj->dsBox != NULL && obj->dsBox->next != NULL)
        xapError(xp, "Multiple BOX");
    if (obj->dsToomany != NULL && obj->dsToomany->next != NULL)
        xapError(xp, "Multiple TOOMANY");
    if (obj->dsArrow != NULL && obj->dsArrow->next != NULL)
        xapError(xp, "Multiple ARROW");
    if (obj->dsLine != NULL && obj->dsLine->next != NULL)
        xapError(xp, "Multiple LINE");
    if (obj->dsConnector != NULL && obj->dsConnector->next != NULL)
        xapError(xp, "Multiple CONNECTOR");
    if (obj->dsText != NULL && obj->dsText->next != NULL)
        xapError(xp, "Multiple TEXT");
    if (obj->dsEx != NULL && obj->dsEx->next != NULL)
        xapError(xp, "Multiple EX");
    if (obj->dsCross != NULL && obj->dsCross->next != NULL)
        xapError(xp, "Multiple CROSS");
    if (obj->dsDot != NULL && obj->dsDot->next != NULL)
        xapError(xp, "Multiple DOT");
    if (obj->dsTriangle != NULL && obj->dsTriangle->next != NULL)
        xapError(xp, "Multiple TRIANGLE");
    if (obj->dsSpan != NULL && obj->dsSpan->next != NULL)
        xapError(xp, "Multiple SPAN");
    }
else if (sameString(name, "BOX"))
    {
    struct dsBox *obj = stack->object;
    if (obj->dsWidth != NULL && obj->dsWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    if (obj->dsOutlinecolor != NULL && obj->dsOutlinecolor->next != NULL)
        xapError(xp, "Multiple OUTLINECOLOR");
    if (obj->dsLinewidth != NULL && obj->dsLinewidth->next != NULL)
        xapError(xp, "Multiple LINEWIDTH");
    }
else if (sameString(name, "TOOMANY"))
    {
    struct dsToomany *obj = stack->object;
    if (obj->dsWidth != NULL && obj->dsWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    if (obj->dsOutlinecolor != NULL && obj->dsOutlinecolor->next != NULL)
        xapError(xp, "Multiple OUTLINECOLOR");
    if (obj->dsLinewidth != NULL && obj->dsLinewidth->next != NULL)
        xapError(xp, "Multiple LINEWIDTH");
    }
else if (sameString(name, "ARROW"))
    {
    struct dsArrow *obj = stack->object;
    if (obj->dsWidth != NULL && obj->dsWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    if (obj->dsParallel != NULL && obj->dsParallel->next != NULL)
        xapError(xp, "Multiple PARALLEL");
    if (obj->dsNortheast != NULL && obj->dsNortheast->next != NULL)
        xapError(xp, "Multiple NORTHEAST");
    if (obj->dsSouthwest != NULL && obj->dsSouthwest->next != NULL)
        xapError(xp, "Multiple SOUTHWEST");
    }
else if (sameString(name, "LINE"))
    {
    struct dsLine *obj = stack->object;
    if (obj->dsWidth != NULL && obj->dsWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "CONNECTOR"))
    {
    struct dsConnector *obj = stack->object;
    if (obj->dsWidth != NULL && obj->dsWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "TEXT"))
    {
    struct dsText *obj = stack->object;
    if (obj->dsFont != NULL && obj->dsFont->next != NULL)
        xapError(xp, "Multiple FONT");
    if (obj->dsFontsize != NULL && obj->dsFontsize->next != NULL)
        xapError(xp, "Multiple FONTSIZE");
    if (obj->dsString != NULL && obj->dsString->next != NULL)
        xapError(xp, "Multiple STRING");
    if (obj->dsStyle != NULL && obj->dsStyle->next != NULL)
        xapError(xp, "Multiple STYLE");
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "EX"))
    {
    struct dsEx *obj = stack->object;
    if (obj->dsWidth != NULL && obj->dsWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "CROSS"))
    {
    struct dsCross *obj = stack->object;
    if (obj->dsWidth != NULL && obj->dsWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "DOT"))
    {
    struct dsDot *obj = stack->object;
    if (obj->dsWidth != NULL && obj->dsWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    }
else if (sameString(name, "TRIANGLE"))
    {
    struct dsTriangle *obj = stack->object;
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    if (obj->dsWidth != NULL && obj->dsWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    if (obj->dsOutlinecolor != NULL && obj->dsOutlinecolor->next != NULL)
        xapError(xp, "Multiple OUTLINECOLOR");
    if (obj->dsLinewidth != NULL && obj->dsLinewidth->next != NULL)
        xapError(xp, "Multiple LINEWIDTH");
    }
else if (sameString(name, "SPAN"))
    {
    struct dsSpan *obj = stack->object;
    if (obj->dsColor != NULL && obj->dsColor->next != NULL)
        xapError(xp, "Multiple COLOR");
    if (obj->dsWidth != NULL && obj->dsWidth->next != NULL)
        xapError(xp, "Multiple WIDTH");
    }
else if (sameString(name, "WIDTH"))
    {
    struct dsWidth *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "COLOR"))
    {
    struct dsColor *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "OUTLINECOLOR"))
    {
    struct dsOutlinecolor *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "LINEWIDTH"))
    {
    struct dsLinewidth *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "PARALLEL"))
    {
    struct dsParallel *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "NORTHEAST"))
    {
    struct dsNortheast *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "SOUTHWEST"))
    {
    struct dsSouthwest *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "FONT"))
    {
    struct dsFont *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "FONTSIZE"))
    {
    struct dsFontsize *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "STRING"))
    {
    struct dsString *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "STYLE"))
    {
    struct dsStyle *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

