/* t.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "t.h"

void *tStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void *tEndHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with end tag.  Checks all required children are loaded. */


void tDasdsnSave(struct tDasdsn *obj, int indent, FILE *f)
/* Save tDasdsn to file. */
{
struct tDsn *tDsn;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASDSN>");
for (tDsn = obj->tDsn; tDsn != NULL; tDsn = tDsn->next)
   tDsnSave(tDsn, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASDSN>\n");
}

struct tDasdsn *tDasdsnLoad(char *fileName)
/* Load tDasdsn from file. */
{
struct DASDSN *obj;
xapParseAny(fileName, "DASDSN", tStartHandler, tEndHandler, NULL, &obj);
return obj;
}

void tDsnSave(struct tDsn *obj, int indent, FILE *f)
/* Save tDsn to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DSN>");
tSourceSave(obj->tSource, indent+2, f);
tDescriptionSave(obj->tDescription, indent+2, f);
tMapmasterSave(obj->tMapmaster, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DSN>\n");
}

struct tDsn *tDsnLoad(char *fileName)
/* Load tDsn from file. */
{
struct DSN *obj;
xapParseAny(fileName, "DSN", tStartHandler, tEndHandler, NULL, &obj);
return obj;
}

void tSourceSave(struct tSource *obj, int indent, FILE *f)
/* Save tSource to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SOURCE");
fprintf(f, " id=\"%s\"", obj->id);
if (obj->version != NULL)
    fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</SOURCE>\n");
}

struct tSource *tSourceLoad(char *fileName)
/* Load tSource from file. */
{
struct SOURCE *obj;
xapParseAny(fileName, "SOURCE", tStartHandler, tEndHandler, NULL, &obj);
return obj;
}

void tDescriptionSave(struct tDescription *obj, int indent, FILE *f)
/* Save tDescription to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DESCRIPTION");
if (obj->href != NULL)
    fprintf(f, " href=\"%s\"", obj->href);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</DESCRIPTION>\n");
}

struct tDescription *tDescriptionLoad(char *fileName)
/* Load tDescription from file. */
{
struct DESCRIPTION *obj;
xapParseAny(fileName, "DESCRIPTION", tStartHandler, tEndHandler, NULL, &obj);
return obj;
}

void tMapmasterSave(struct tMapmaster *obj, int indent, FILE *f)
/* Save tMapmaster to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<MAPMASTER>");
fprintf(f, "%s", obj->text);
fprintf(f, "</MAPMASTER>\n");
}

struct tMapmaster *tMapmasterLoad(char *fileName)
/* Load tMapmaster from file. */
{
struct MAPMASTER *obj;
xapParseAny(fileName, "MAPMASTER", tStartHandler, tEndHandler, NULL, &obj);
return obj;
}

void *tStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASDSN"))
    {
    struct tDasdsn *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "DSN"))
    {
    struct tDsn *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASDSN"))
            {
            struct tDasdsn *parent = st->object;
            slAddHead(&parent->tDsn, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "SOURCE"))
    {
    struct tSource *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct tDsn *parent = st->object;
            slAddHead(&parent->tSource, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "DESCRIPTION"))
    {
    struct tDescription *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "href"))
            obj->href = cloneString(val);
        }
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct tDsn *parent = st->object;
            slAddHead(&parent->tDescription, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "MAPMASTER"))
    {
    struct tMapmaster *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct tDsn *parent = st->object;
            slAddHead(&parent->tMapmaster, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void *tEndHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASDSN"))
    {
    struct tDasdsn *obj = stack->object;
    if (obj->tDsn == NULL)
        xapError(xp, "Missing DSN");
    }
if (sameString(name, "DSN"))
    {
    struct tDsn *obj = stack->object;
    if (obj->tSource == NULL)
        xapError(xp, "Missing SOURCE");
    if (obj->tSource->next != NULL)
        xapError(xp, "Multiple SOURCE");
    if (obj->tDescription != NULL && obj->tDescription->next != NULL)
        xapError(xp, "Multiple DESCRIPTION");
    if (obj->tMapmaster == NULL)
        xapError(xp, "Missing MAPMASTER");
    if (obj->tMapmaster->next != NULL)
        xapError(xp, "Multiple MAPMASTER");
    }
if (sameString(name, "SOURCE"))
    {
    struct tSource *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
if (sameString(name, "DESCRIPTION"))
    {
    struct tDescription *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
if (sameString(name, "MAPMASTER"))
    {
    struct tMapmaster *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

